C
C************************************************************************
C************************************************************************
C*                                                                     **
C*  BMC2.FOR -- MONTE-CARLO PROGRAM FOR BOOT-STRAPPED STANDARD ERRORS  **
C*                                                                     **
C*                              23 MAY 1998                            **
C*                                                                     **
C*  THE BLACK BOX -- PERFORMS SINGULAR VALUE DECOMPOSITION ON A MATRIX **
C*    WITH MISSING ENTRIES.  DEVELOPED BY KEITH T. POOLE, JULY-OCTOBER **
C*    1982.  FURTHER DEVELOPMENT IN NOVEMBER-DECEMBER 1992.            **
C*                                                                     **
C*                                                                     **
C************************************************************************
C************************************************************************
C
      DIMENSION XBIGONE(3539,60),KISSUE(100),KID(3539),W(152,127),
     C          KMISS(60,10),XDATA(3539,125),XT(3539,25),RSAVE(25,25),
     C          YHAT(3539),UUU(3539,25),VVV(3539,25),LID(3539),
     C          DC(152),
     C          XBIG3(3539,60),TRUEW(152,10),CONSUM(152),
     C          XRAND(3539),LL(3539),WEISUM(152,10),T2(152),
     C          W1(152,10),TRUEWW(152,10),PSIT(152,10),
     C          BLACKBOY(152,152),
     C          VCOV(152,152),XSAVE(152,152)
      COMMON /WORKSP/ RWKSP
      REAL RWKSP(61913)
      integer*2 itim1,itim2,itim3,itim4,jtim1,jtim2,jtim3,jtim4
      CHARACTER*120 FNAME,FMT,TITLE
      CHARACTER*10 CAND(20)
      OPEN(4,FILE='BMCSTR.DAT',STATUS='OLD')
      OPEN(23,FILE='BMC223.DAT')
      OPEN(28,FILE='BMC228.DAT')
      OPEN(29,FILE='BMC229.DAT')
C
C
  70  FORMAT(' ITERATION RECORD'
     C/3X,'DIM',5X,'ERROR',4X,'EXPLAINED',
     C6X,'PERCENT',2X,'CUM PERCENT',3X,'R-SQUARE',2X,'STD ERR EST')
  101 FORMAT(I5,8F8.3/5X,8F8.3)
  113 FORMAT(1X,I5,8F12.4)
  195 FORMAT(' ITERATION SUMMARY')
  196 FORMAT(' NUMBER OF DIMENSIONS='I4)
  197 FORMAT(5X,'PSI-TRANSPOSE*PSI')
  198 FORMAT(I6,20F7.3)
  199 FORMAT(1X,'CONSTRAINT CHECKS ON PSI AND W'/
     C       5X,'SUM OF COLUMNS OF PSI'/
     C       6X,35F10.4)
  200 FORMAT(I6,35F10.4)
  201 FORMAT(2I7,35F7.3)
  202 FORMAT(5X,'W-TRANSPOSE*W')
  225 FORMAT(1X,A10,I7,35F7.3)
  301 FORMAT(' NUMBER OF CASES',3I6)
  311 format(' Iseed=',i9)
  315 FORMAT(' R-SQUARE ',I8,F7.3)
  330 FORMAT(I5,7F10.4)
  337 FORMAT(' RANK CHECK OF PSI*W',I5)
  341 FORMAT(' RANK OF SCHOENMANN ROTATION MATRIX',I5)
  342 FORMAT(' COVARIANCE MATRIX')
 1000 format(22x,4(i2.2,'.'))
 1001 format(' ELAPSED TIME OF JOB  ',4(i2.2,'.'))
 1002 FORMAT(8I5)
 1003 FORMAT(A10)
 1082 format(A120)
 2222 FORMAT(1X,78('*'))
C
C
      CALL IWKIN(61913)
C
C
      call gettim(itim1,itim2,itim3,itim4)
      iseed=1000*itim1+100*itim2+1000*itim3+200*itim4
C
      write(*,311)iseed
      write(23,311)iseed
C
      read(4,1082)FNAME 
      write(23,1082)FNAME
      write(*,1082)FNAME
      open(22,file=FNAME,STATUS='OLD',RECL=3600)
      READ(4,'(A)')TITLE
      WRITE(23,'(A)')TITLE
      WRITE(*,'(A)')TITLE
      READ(4,1002)NS,NY,NMISS,KVMIN,NTRIAL
      WRITE(23,1002)NS,NY,NMISS,KVMIN,NTRIAL
      WRITE(*,1002)NS,NY,NMISS,KVMIN,NTRIAL
C
C  INCREMENT NTRIAL BY 1 -- THE FIRST PASS IS THE ACTUAL Xo MATRIX
C
      NTRIAL=NTRIAL+1
      READ(4,'(A)')FMT
      WRITE(23,'(A)')FMT
      WRITE(*,'(A)')FMT
      DO 111 I=1,NY
      READ(4,1003)CAND(I)
      WRITE(23,1003)CAND(I)
      WRITE(*,1003)CAND(I)
      READ(4,1002)(KMISS(I,J),J=1,NMISS)
      WRITE(23,1002)(KMISS(I,J),J=1,NMISS)
      WRITE(*,1002)(KMISS(I,J),J=1,NMISS)
  111 CONTINUE
C      NY=14
C      NS=3
C
      I=0
      II=0
  500 READ(22,FMT,END=400)MID,(KISSUE(J),J=1,NY)
      I=I+1
      IMARK=0
      DO 1 J=1,NY
      DO 112 K=1,NMISS
      IF(KISSUE(J).EQ.KMISS(J,K))THEN 
         KISSUE(J)=-999
         IMARK=IMARK+1
         GO TO 1
      ENDIF
  112 CONTINUE
  1   CONTINUE
      IF((NY-IMARK).LT.KVMIN)GO TO 500
      II=II+1
      KID(II)=MID
      DO 11 J=1,NY
      XBIGONE(II,J)=FLOAT(KISSUE(J))
      XBIG3(II,J)=FLOAT(KISSUE(J))
  11  CONTINUE
      GO TO 500
  400 WRITE(*,301)I,II
      NOBS=II
      WRITE(23,301)NOBS
C
C  SUBROUTINE BLACKB--GENERATES MULTI-DIMENSIONAL STARTING VALUES 
C    FOR LEGISLATORS BY PERFORMING A PSEUDO-SINGULAR VALUE 
C    DECOMPOSITION OF NY ROLL CALLS
C
C
      WRITE(23,2222)
      WRITE(23,2222)
      DO 999 KKK=1,NS
      DO 9998 J=1,NY
      DO 9998 I=1,NOBS
 9998 XBIG3(I,J)=XBIGONE(I,J)
      WRITE(23,2222)
      WRITE(23,196)KKK
      WRITE(*,196)KKK
C
C  BOOTSTRAP LOOP BEGINS HERE
C
      DO 9999 IIII=1,NTRIAL
      IF(IIII.GT.1)THEN
         DO 5 II=1,NOBS
         DO 10 JJ=1,NY
         XBIG3(II,JJ)=0.0
  10     CONTINUE
         DO 3 I=1,NOBS
         LL(I)=I
         XRAND(I)=URAND(ISEED)
  3      CONTINUE
         CALL RSORT(XRAND,NOBS,LL)
         DO 4 JJ=1,NY
         XBIG3(II,JJ)=XBIGONE(LL(1),JJ)
  4      CONTINUE
  5      CONTINUE
      ENDIF
C
      call BLACKB(NOBS,NY,KKK,XBIG3,XDATA,W,DC,SVSUM)
C  
C  CONSTRAINT CHECKS
C
      DO 233 K=1,KKK
      SUM=0.0
      DO 234 I=1,NOBS
      SUM=SUM+XDATA(I,K)
  234 CONTINUE
      VVV(1,K)=SUM/FLOAT(NOBS)
  233 CONTINUE
      WRITE(23,199)(VVV(1,K),K=1,KKK)
      DO 227 J=1,KKK
      DO 227 K=1,KKK
      SUM=0.0
      DO 228 I=1,NOBS
      SUM=SUM+XDATA(I,J)*XDATA(I,K)
  228 CONTINUE
  227 VVV(J,K)=SUM
      WRITE(23,197)
      DO 229 I=1,KKK
  229 WRITE(23,200)I,(VVV(I,J),J=1,KKK)
      WRITE(23,202)
      DO 230 J=1,KKK
      DO 230 K=1,KKK
      SUM=0.0
      DO 231 I=1,NY
      SUM=SUM+W(I,J+1)*W(I,K+1)
  231 CONTINUE
  230 VVV(J,K)=SUM
      DO 232 I=1,KKK
  232 WRITE(23,200)I,(VVV(I,J),J=1,KKK)
      ASUM=0.0
      BSUM=0.0
      CSUM=0.0
      DSUM=0.0
      ESUM=0.0
      SUME=0.0
      KK=0
      DO 223 J=1,NY
      AASUM=0.0
      BBSUM=0.0
      CCSUM=0.0
      DDSUM=0.0
      EESUM=0.0
      KJJ=0
      DO 224 I=1,NOBS
      SUM=0.0
      DO 726 K=1,KKK
      SUM=SUM+XDATA(I,K)*W(J,K+1)
      W1(J,K+1)=W(J,K+1)
  726 CONTINUE
      XT(I,J)=SUM
      AA=SUM+W(J,1)
      W1(J,1)=W(J,1)
      IF(XBIG3(I,J).EQ.-999.0)GO TO 224
      BB=XBIG3(I,J)
      SUME=SUME+(AA-BB)**2
      AASUM=AASUM+AA
      BBSUM=BBSUM+BB
      CCSUM=CCSUM+AA*AA
      DDSUM=DDSUM+BB*BB
      EESUM=EESUM+AA*BB
      KJJ=KJJ+1
  224 CONTINUE
      AAA=FLOAT(KJJ)*EESUM-AASUM*BBSUM
      BBB=FLOAT(KJJ)*CCSUM-AASUM*AASUM
      CCC=FLOAT(KJJ)*DDSUM-BBSUM*BBSUM
      RRR=0.0
      IF(ABS(BBB*CCC).GT.0.0)RRR=(AAA*AAA)/(BBB*CCC)
      W(J,KKK+2)=RRR
      LID(J)=KJJ
      ASUM=ASUM+AASUM
      BSUM=BSUM+BBSUM
      CSUM=CSUM+CCSUM
      DSUM=DSUM+DDSUM
      ESUM=ESUM+EESUM
      KK=KK+KJJ
  223 CONTINUE
      AA=FLOAT(KK)*ESUM-ASUM*BSUM
      BB=FLOAT(KK)*CSUM-ASUM*ASUM
      CC=FLOAT(KK)*DSUM-BSUM*BSUM
      RRR=(AA*AA)/(BB*CC)
      WRITE(*,315)KK,RRR
      WRITE(23,315)KK,RRR
C
      RSAVE(KKK,1)=SUME
      RSAVE(KKK,2)=RRR
      RSAVE(KKK,3)=SQRT(SUME/FLOAT(KK - KKK*(NOBS+NY) + NY))
C
C  *****patched in code*****
C
      XTOL=.001
      CALL LSVRR(NOBS,NY,XT,3539,21,XTOL,IRANK,YHAT,UUU,
     C           3539,VVV,3539)
      WRITE(23,337)IRANK
      DO 464 I=1,NS+3
      WRITE(23,330)I,YHAT(I)
  464 CONTINUE
C
C
C  WRITE OUT COLUMN PARAMETERS
C
      DO 222 I=1,NY
      WRITE(28,225)CAND(I),LID(I),(W(I,JJ),JJ=1,KKK+2)
  222 CONTINUE
C
C  WRITE OUT ROW PARAMETERS
C
C      DO 742 I=1,NOBS
C      WRITE(24,201)I,KID(I),(XDATA(I,J),J=1,KKK)
C      WRITE(*,201)I,KID(I), (UUU(I,J),J=1,KKK)
C  742 CONTINUE
      IF(IIII.EQ.1)THEN
         DO 7 I=1,NY
         DO 77 K=1,KKK+1
         TRUEW(I,K)=W1(I,K)
         WEISUM(I,K)=0.0
  77     CONTINUE
         CONSUM(I)=0.0
  7      CONTINUE
      ENDIF
      IF(IIII.GT.1)THEN
C
C  ROTATE TRUE COORDINATES TO BEST FIT ESTIMATED COORDINATES USING
C    SCHONEMANN'S ORTHOGONAL PROCRUSTES SOLUTION
C
         DO 831 I=1,NY
         DO 832 K=1,KKK+1
         PSIT(I,K)=W1(I,K)
         TRUEWW(I,K)=TRUEW(I,K)
  832    CONTINUE
  831    CONTINUE
         DO 833 L=1,KKK
         DO 834 K=1,KKK
         SUM=0.0
         DO 835 I=1,NY
         SUM=SUM+TRUEWW(I,K+1)*PSIT(I,L+1)
  835    CONTINUE
         BLACKBOY(K,L)=SUM
  834    CONTINUE
  833    CONTINUE
  
C  CALL SINGULAR VALUE DECOMPOSITION ROUTINE
C
         XTOL=.001
         CALL LSVRR(KKK,KKK,BLACKBOY,152,21,XTOL,IRANK,YHAT,UUU,
     C           3539,VVV,3539)
C
         WRITE(23,341)IRANK
C
C  COMPUTE ROTATION MATRIX
C
         WRITE(23,342)
         DO 836 K=1,KKK
         DO 837 M=1,KKK
         SUM=0.0
         DO 838 L=1,KKK
         SUM=SUM+UUU(K,L)*VVV(M,L)
  838    CONTINUE
         VCOV(K,M)=SUM
  837    CONTINUE
         WRITE(23,330)K,YHAT(K),(VCOV(K,L),L=1,KKK) 
  836    CONTINUE
C
C  ROTATE TRUE COORDINATES
C
         DO 839 I=1,NY
         DO 840 K=1,KKK
         SUM=0.0
         DO 841 L=1,KKK
         SUM=SUM+TRUEWW(I,L+1)*VCOV(L,K)
  841    CONTINUE
         XSAVE(I,K+1)=SUM
  840    CONTINUE
         XSAVE(I,1)=TRUEWW(I,1)
  839    CONTINUE
C
         DO 6 I=1,NY
         CONSUM(I)=CONSUM(I)+(XSAVE(I,1)-W1(I,1))**2
         DO 66 K=1,KKK
         WEISUM(I,K)=WEISUM(I,K)+(XSAVE(I,K+1)-W1(I,K+1))**2
  66     CONTINUE
  6      CONTINUE
      ENDIF
 9999 CONTINUE
      DO 8 I=1,NY
      CONSUM(I)=SQRT(CONSUM(I)/FLOAT(NTRIAL-1))
      DO 88 K=1,KKK
      WEISUM(I,K)=SQRT(WEISUM(I,K)/FLOAT(NTRIAL-1))
  88  CONTINUE
      T1=TRUEW(I,1)/CONSUM(I)
      DO 888 K=1,KKK
      T2(K)=TRUEW(I,K+1)/WEISUM(I,K)
  888 CONTINUE
      WRITE(29,101)I,TRUEW(I,1),(TRUEW(I,K+1),K=1,KKK),
     C             CONSUM(I),(WEISUM(I,K),K=1,KKK),T1,
     C             (T2(K),K=1,KKK)
  8   CONTINUE
  999 CONTINUE
      WRITE(23,2222)
      WRITE(23,70)
      WRITE(*,70)
      DO 69 J=1,NS
      AA=(SVSUM-RSAVE(J,1))/SVSUM
      CCC=SVSUM-RSAVE(J,1)
      IF(J.EQ.1)BB=SVSUM
      IF(J.GT.1)BB=RSAVE(J-1,1)
      SUM=(BB-RSAVE(J,1))/SVSUM
      WRITE(23,113)J,RSAVE(J,1),CCC,SUM*100.0,AA*100.0,RSAVE(J,2),
     C              RSAVE(J,3)
  69  WRITE(* ,113)J,RSAVE(J,1),CCC,SUM*100.0,AA*100.0,RSAVE(J,2),
     C              RSAVE(J,3)
      WRITE(23,2222)
C
      WRITE(23,2222)
      call gettim(jtim1,jtim2,jtim3,jtim4)
      write(*,1000)itim1,itim2,itim3,itim4
      write(*,1001)jtim1,jtim2,jtim3,jtim4
      STOP
      END
C
C  ***********************************************************************
C    SUBROUTINE BLACKB
C      
C      PERFORMS THE FOLLOWING DECOMPOSITION:
C
C           X = [PW' + Jc'] + E
C         
C          WHERE X IS NPxNY, P IS NPxNF, W IS NYxNF, J IS A NP LENGTH
C            VECTORS OF 1'S, c IS A NY VECTOR OF CONSTANTS,
C            AND E IS NPxNY MATRIX OF ERROR WHICH IS MINIMIZED
C
C  ***********************************************************************
C  
      SUBROUTINE BLACKB(NP,NY,NF,XBIGONE,XDATA,W,DC,SVSUM)
      DIMENSION X(3539,152),XX(408),FAL1(152),FAL2(152),
     C          PSIX(3539,152),XS(3539,152),LL(152),W(152,127),
     C          SQU(152),R(152,152),D(152),WK(500),ROOTC(3539,152),
     C          CROOT(3539,152),DD(152),DC(152),CC(152),XT(3539,152),
     C          XSS(3539,152),MPOS(152),TSUM(408),DDD(152),
     C          XBIGONE(3539,60),XDATA(3539,125),DX(152),
     C          UUU(3539,152),VVV(3539,152),WSAVE(127,127),
     C          XSAVE(3539,60),YHAT(3539)
      COMMON /AREA1/ JR,LR
      COMMON /XSREG/ AREG,BREG
      COMMON /WORKSP/ RWKSP
      REAL RWKSP(61913)
  23  FORMAT(' CORRELATION MATRIX FOR PSIX')
  70  FORMAT(' ITERATION RECORD'/3X,'DIM',5X,'ERROR',5X,'EXPLAINED',
     C6X,'PERCENT',2X,'CUM PERCENT',3X,'R-SQUARE')
  86  FORMAT(1X,'SINGULAR VALUES OF ESTIMATED MATRICES'/
     C       1X,'FIRST COLUMN:  ORIGINAL MATRIX WITH FILLED IN MISSING E
     CNTRIES'/
     C       1X,'SECOND COLUMN: REPRODUCED MATRIX -- PSI*W + Jc'/
     C       1X,'THIRD COLUMN:  ORIGINAL MATRIX WITH FILLED IN MISSING E
     CNTRIES MINUS THE ORIGINAL COLUMN MEANS'/
     C       1X,'FOURTH COLUMN:  PSI*W')
  113 FORMAT(1X,I5,8F12.4)
  199 FORMAT(' CONSTRAINT CHECKS ON PSI AND W'/6X,35F7.3)
  200 FORMAT(I6,35F10.4)
  300 FORMAT(1X,'NUMBER OF ROWS               =',I6/
     C       1X,'NUMBER OF COLUMNS            =',I6/
     C       1X,'TOTAL NUMBER OF DATA ENTRIES =',I6/
     C       1X,'NUMBER MISSING ENTRIES       =',I6/
     C       1X,'PERCENT MISSING DATA         =',F15.5/
     C       1X,'SUM OF SQUARES GRAND MEAN    =',F15.5)
  301 FORMAT(2I5,F7.3)
  335 FORMAT(' CORRECTION ROW=',I3,1X,' # POSITIVE=',I5)
  336 FORMAT(1X,25I3/1X,25I3)
  337 FORMAT(' RANK CHECK',I5)
  338 FORMAT(I5,7F10.4)
  521 FORMAT(' CROSS PRODUCT MATRIX FOR PSIX')
 1113 FORMAT(I3,12F10.3)
 2222 FORMAT(1X,78('*'))
 7200 FORMAT(' ERROR PARAMETER EIGENVALUE ROUTINE=',I4)
 9011 FORMAT(I5,10X,3F10.4)
 9012 FORMAT(3I5,3F10.4)
      JR=23
      LR=JR
      NF1=NF+1
      DO 349 J=1,NY
      DC(J)=0.0
      CC(J)=0.0
  349 LL(J)=0.0
      KTOT=0
      SVSUM=0.0
      SWSUM=0.0
      WRITE(23,2222)
C
C
      DO 600 I=1,NP
      SUM=0.0
      SUMA=0.0
      KK=0
      DO 30 J=1,NY
      X(I,J)=XBIGONE(I,J)
      IF(X(I,J).NE.-999.0)THEN
         SUM=SUM+X(I,J)*X(I,J)
         SUMA=SUMA+X(I,J)
         KK=KK+1
      ENDIF
      XS(I,J)=X(I,J)
  30  CONTINUE
      KTOT=KTOT+KK
      SVSUM=SVSUM+SUM
      SWSUM=SWSUM+SUMA
      DO 31 J=1,NY
      XSS(I,J)=X(I,J)
      IF(X(I,J).EQ.-999.0)GO TO 31
      LL(J)=LL(J)+1
      DC(J)=DC(J)+X(I,J)
      CC(J)=CC(J)+X(I,J)*X(I,J)
  31  CONTINUE
  600 CONTINUE
C
C   COMPUTE NY COLUMN MEANS PLACE IN DC(NY), COMPUTE SUM OF SQUARES
C     AND PERCENT MISSING DATA
C
      DO 32 J=1,NY
      D(J)=CC(J)-(DC(J)*DC(J))/FLOAT(LL(J))
      DC(J)=DC(J)/FLOAT(LL(J))
C      WRITE(*,301)J,LL(J),DC(J)
C      WRITE(23,301)J,LL(J),DC(J)
  32  CONTINUE
      SVSUM=SVSUM-(SWSUM**2)/FLOAT(KTOT)
      LTOT=NP*NY
      PMISS=FLOAT(LTOT-KTOT)/FLOAT(LTOT)
      LTOT=LTOT-KTOT
      IF(NF.EQ.1)THEN
         WRITE(23,300)NP,NY,KTOT,LTOT,PMISS*100.0,SVSUM
         WRITE(* ,300)NP,NY,KTOT,LTOT,PMISS*100.0,SVSUM
         WRITE(23,2222)
         WRITE(*,2222)
      ENDIF   
C
C  COMPUTE CORRELATION NY BY NY CORRELATION MATRIX AND VECTOR OF SIGN
C    CHANGES FOR COLUMNS OF X/XS/XSS
C
      call CORR2(NP,NY,X,R,LL,MPOS,KS,KPOS,1)
C
C  MASTER LOOP FOR NF DIMENSIONS--ONE DIMENSION IS EXTRACTED AT A TIME.
C     THE RESIDUAL MATRIX IS COMPUTED AFTER EACH DIMENSION IS EXTRACTED
C     AND IT IS USED AS X IN THE FORMULA BELOW.  AT THE END OF THIS
C     PROCESS:
C
C              P'P = I, WITH P BEING NOBSxNF, W NYxNF, c NYx1
C
C           X = [PW' + Jc'] + E
C
      DO 9999 JJJ=1,NF
      KKK=JJJ
      DO 10 J=1,NY
      XX(J)=1.0
      XX(J+NY)=-DC(J)
      IF(JJJ.GT.1)XX(J+NY)=0.0
  10  CONTINUE
      XXK=0.0
      TXB=0.0
      KKT=0
C
C  AT FIRST ITERATION JJJ = 1 THE COLUMN MEANS ARE SUBTRACTED
C     FOR SUBSEQUENT ITERATIONS, COLUMN MEANS = 0.  NOTE USE OF
C     COLUMN SIGN CHANGES (LL(NY)) FROM CORR2
C
      DO 3 I=1,NP
      KK=0
      SUM=0.0
      DO 1 J=1,NY
      IF(X(I,J).EQ.-999.0)GO TO 1
      SUM=SUM+(X(I,J)*XX(J)+XX(J+NY))*FLOAT(LL(J))
      KK=KK+1
  1   CONTINUE
C
C  XT(NOBS,1) = (X - COL. MEAN)xSIGN CHANGE, SUMMED OVER ITH ROW--THIS
C     IS THE STARTING ESTIMATE OF THE FIRST COLUMN OF P (PSIX BELOW).
C     THE MEAN OF XT(NOBS,1) IS THEN SUBTRACTED OUT BELOW SO THAT THE
C     STARTING ESTIMATE SUMS TO ZERO.
C     XT(NOBS,2) = 1 FOR THE LINEAR REGRESSIONS BELOW---TO PICK UP THE
C       INTERCEPT VECTOR, c
C
      WXB=SUM/(FLOAT(KK))
C
      KKT=KKT+1
      TXB=TXB+WXB
      XT(I,1)=WXB
      XXK=XXK+XT(I,1)*XT(I,1)
  3   CONTINUE
      TXB=TXB/FLOAT(KKT)
      XXK=XXK-FLOAT(KKT)*TXB*TXB
      DO 40 I=1,NP
      XT(I,1)=(XT(I,1)-TXB)
      XT(I,2)=1.0
  40  CONTINUE
C
C  ALTERNATING LEAST SQUARES IS NOW PERFORMED TO FIRST ESTIMATE W AND c--
C    SUBROUTINE REG--ESTIMATES OF W AND c ARE RETURNED IN W(NY,NF+1)
C  W AND c ARE THEN USED TO ESTIMATE P IN SUBROUTINE REG2--
C  RESIDUALS ARE RETURNED IN X(NOBS,NY)
C
      DO 444 MM=1,4
      call REG(NP,1,NY,TSUM,W,XS,X,XT,1,1,KKK)
      call REG2(NP,1,NY,W,XS,X,XT,SQU,PXB,PXS,KKK,1)
C
C  PXB IS THE MEAN OF THE ESTIMATED COLUMN OF P
C  PXS IS THE VARIANCE OF THE ESTIMATED COLUMN OF P
C
      QXS=PXS
      XCOR=SQRT(XXK/PXS)
C      WRITE(JR,113)MM,XXK,QXS,PXS,XCOR,PXB,TXB
      DO 444 I=1,NP
C
C  THE ESTIMATED MEAN, PXB, IS SUBTRACTED OFF AND THE COLUMN IS
C    ADJUSTED SO IT HAS THE ORIGINAL SUM OF SQUARES WITH MEAN ZERO
C
      PSIX(I,JJJ)=(XT(I,1)-PXB)*XCOR
      XT(I,1)=(XT(I,1)-PXB)*XCOR
  444 CONTINUE
C
C  END OF A.L.S. LOOP
C
C  IF THIS IS THE LAST ITERATION, I.E. JJJ = NF, THEN PUT A VECTOR
C    OF ONES INTO THE NF+1 COLUMN OF THE ESTIMATED P MATRIX
C    AND RESET X(NOBS,NY)--WHICH STARTED AS THE ORIGINAL DATA AND
C    THEN BECAME THE RESIDUAL MATRIX AT EACH STAGE--BACK TO THE
C    ORIGINAL DATA WHICH WAS SAVED IN XSS(NOBS,NY)
C
C  IF THIS IS NOT THE LAST ITERATION, PUT THE RESIDUALS X(NOBS,NY) INTO
C    XS(NOBS,NY), AND CALL CORR2 TO GET THE SIGN CHANGES FOR THE COLUMNS
C    WHICH ARE USED ABOVE
C
      DO 461 I=1,NP
      IF(KKK.EQ.NF)PSIX(I,NF+1)=1.0
      DO 461 J=1,NY
      IF(KKK.EQ.NF)X(I,J)=XSS(I,J)
  461 XS(I,J)=X(I,J)
      IF(KKK.EQ.NF)GO TO 9999
      call CORR2(NP,NY,X,R,LL,MPOS,KS,KPOS,1)
 9999 CONTINUE
C
C  WRITE OUT CORRELATION AND CROSS PRODUCT MATRIX OF P
C
C      WRITE(JR,23)
C      call CORR2(NP,NF,PSIX,R,LL,MPOS,KS,KPOS,1)
C      WRITE(LR,521)
C      call PSIPRM(NP,NF1,PSIX)
C
C  PERFORM A.L.S. WITH FULL P MATRIX UNTIL CONVERGENCE
C
      DO 222 NN=1,5
      call REG(NP,NF,NY,TSUM,W,XS,X,PSIX,1,1,NF)
      call REG2(NP,NF,NY,W,XS,X,PSIX,SQU,PXB,PXS,NF,NF)
C 
C  CENTER THE PSI MATRIX AT ZERO
C
      DO 42 K=1,NF
      SUM=0.0
      DO 41 I=1,NP
      SUM=SUM+PSIX(I,K)
  41  CONTINUE
      SUM=SUM/FLOAT(NP)
      DO 43 I=1,NP
      PSIX(I,K)=PSIX(I,K)-SUM
  43  CONTINUE
  42  CONTINUE
      AA=ABS(AREG-BREG)
      IF(AA.LT..01)GO TO 223
  222 CONTINUE
  223 NFPS=NF+1
C
C  COMPUTE PW' + Jc' AND PUT INTO X(NOBS,NY)
C  FOR MISSING DATA, INSERT ESTIMATED VALUES IN X INTO THE 
C    ORIGINAL DATA MATRIX USING XT(NOBS,NY) SO THAT SINGULAR VALUES
C    CAN BE ESTRACTED FROM ORIGINAL DATA
C
      DO 60 I=1,NP
      DO 601 K=1,NY
  601 XT(I,K)=0.0
      DO 61 K=1,NY
      WK(K)=0.0
      WK(K+NY)=0.0
      SUM=0.0
      DO 62 J=1,NFPS
  62  SUM=SUM+PSIX(I,J)*W(K,J)
  61  X(I,K)=SUM
      DO 59 JJ=1,NY
      IF(XS(I,JJ).NE.-999.0)XT(I,JJ)=XS(I,JJ)
      IF(XS(I,JJ).EQ.-999.0)XT(I,JJ)=X(I,JJ)
  59  CONTINUE
  60  CONTINUE
C
C  EXTRACT SINGULAR VALUES FROM ORIGINAL DATA MATRIX WITH ESTIMATES
C   INSERTED FOR MISSING DATA
C
      DO 71 I=1,NY
      DO 71 J=1,NY
      SUM=0.0
      DO 73 K=1,NP
  73  SUM=SUM+XT(K,I)*XT(K,J)
  71  ROOTC(I,J)=SUM
      CALL RS(3539,NY,ROOTC,D,1,CROOT,FAL1,FAL2,IERR)
      DO 729 I=1,NP
      DO 729 J=1,NY
      ROOTC(I,J)=XT(I,J)
      CROOT(I,J)=XT(I,J)-DC(J)
  729 CONTINUE
      XTOL=.001
      CALL LSVRR(NP,NY,ROOTC,3539,21,XTOL,IRANK,YHAT,UUU,
     C           3539,VVV,3539)
C      WRITE(23,337)IRANK
      DO 464 I=1,NY
C      WRITE(23,338)I,YHAT(I)
      D(I)=YHAT(I)
  464 CONTINUE
      XTOL=.001
      CALL LSVRR(NP,NY,CROOT,3539,21,XTOL,IRANK,YHAT,UUU,
     C           3539,VVV,3539)
C      WRITE(23,337)IRANK
      DO 465 I=1,NY
C      WRITE(23,338)I,YHAT(I)
      DX(I)=YHAT(I)
  465 CONTINUE
C      WRITE(JR,7200)IERR
C      WRITE(*,7200)IERR
      ESUM=0.0
      SUMM=0.0
      SUMM1=0.0
      SUMM2=0.0
      DO 83 I=1,NP
      DO 83 J=1,NY
      SUMM=SUMM+X(I,J)**2
      IF(XS(I,J).NE.-999.0)ESUM=ESUM+(X(I,J)-XS(I,J))**2
      IF(XS(I,J).NE.-999.0)SUMM1=SUMM1+X(I,J)**2
      IF(XS(I,J).EQ.-999.0)SUMM2=SUMM2+X(I,J)**2
C
C  STORE PW' + Jc' IN XSS(NOBS,NY) AND COMPUTE PW' AND STORE IN XT(NOBS,NY)
C
      XSS(I,J)=X(I,J)
  83  XT(I,J)=X(I,J)-W(J,NF+1)
C
C  PERFORM SINGULAR VALUE DECOMPOSITION OF PW' + Jc'
C
      DO 75 I=1,NY
      DO 75 J=1,NY
      SUM=0.0
      DO 76 K=1,NP
      SUM=SUM+XSS(K,I)*XSS(K,J)
  76  CONTINUE
  75  ROOTC(I,J)=SUM
      CALL RS(3539,NY,ROOTC,DDD,1,CROOT,FAL1,FAL2,IERR)
      DO 728 I=1,NP
      DO 728 J=1,NY
      ROOTC(I,J)=XSS(I,J)
  728 CONTINUE
      XTOL=.001
      CALL LSVRR(NP,NY,ROOTC,3539,21,XTOL,IRANK,YHAT,UUU,
     C           3539,VVV,3539)
C      WRITE(23,337)IRANK
      DO 463 I=1,NY
C      WRITE(23,338)I,YHAT(I)
      DDD(I)=YHAT(I)
  463 CONTINUE
C      WRITE(JR,7200)IERR
C      WRITE(*,7200)IERR
C
C  PERFORM SINGULAR VALUE DECOMPOSITION OF PW'
C
      DO 77 I=1,NY
      DO 77 J=1,NY
      SUM=0.0
      DO 78 K=1,NP
      SUM=SUM+XT(K,I)*XT(K,J)
  78  CONTINUE
  77  ROOTC(I,J)=SUM
      CALL RS(3539,NY,ROOTC,DD,1,CROOT,FAL1,FAL2,IERR)
      DO 727 I=1,NP
      DO 727 J=1,NY
      ROOTC(I,J)=XT(I,J)
  727 CONTINUE
      XTOL=.001
      CALL LSVRR(NP,NY,ROOTC,3539,21,XTOL,IRANK,YHAT,UUU,
     C           3539,VVV,3539)
C      WRITE(23,337)IRANK
      DO 462 I=1,NP
      DD(I)=YHAT(I)
      DO 462 JJ=1,NF
      PSIX(I,JJ)=UUU(I,JJ)*SQRT(YHAT(JJ))
  462 CONTINUE
      DO 460 I=1,NY
      DO 460 JJ=1,NF
      W(I,JJ)=VVV(I,JJ)*SQRT(YHAT(JJ))
  460 CONTINUE
C      WRITE(JR,7200)IERR
C      WRITE(*,7200)IERR
C  
C  CONSTRAINT CHECKS
C
      DO 233 K=1,NFPS
      SUM=0.0
      DO 234 I=1,NP
      SUM=SUM+PSIX(I,K)
  234 CONTINUE
      VVV(1,K)=SUM/FLOAT(NP)
  233 CONTINUE
C      WRITE(23,199)(VVV(1,K),K=1,NF)
      DO 227 J=1,NF
      DO 227 K=1,NF
      SUM=0.0
      DO 228 I=1,NP
      SUM=SUM+PSIX(I,J)*PSIX(I,K)
  228 CONTINUE
  227 VVV(J,K)=SUM
      DO 229 I=1,NF
C      WRITE(23,200)I,(VVV(I,J),J=1,NF)
  229 CONTINUE
      DO 230 J=1,NF
      DO 230 K=1,NF
      SUM=0.0
      DO 231 I=1,NY
      SUM=SUM+W(I,J)*W(I,K)
  231 CONTINUE
  230 VVV(J,K)=SUM
      DO 232 I=1,NF
C      WRITE(23,200)I,(VVV(I,J),J=1,NF)
  232 CONTINUE
C
C  SAVE PSI AND W HERE
C
      DO 266 J=1,NF
      DO 266 I=1,NP
      XSAVE(I,J)=PSIX(I,J)
  266 CONTINUE
      DO 265 J=1,NF
      DO 265 I=1,NY
      WSAVE(I,J+1)=W(I,J)
      WSAVE(I,1)=W(I,NF+1)
  265 CONTINUE        
C
C
C  WRITE OUT SINGULAR VALUES FOR ORIGINAL DATA (USING ESTIMATES FOR
C   MISSING ENTRIES), PW' + Jc', AND PW'
C
      WRITE(JR,86)
      DO 87 J=1,NY
      IF(J.GT.NF+3)GO TO 87
      WRITE(23,1113)J,D(J),DDD(J),DX(J),DD(J)
      WRITE(*,1113)J,D(J),DDD(J),DX(J),DD(J)
  87  CONTINUE
C
C
      WRITE(JR,2222)
C
C  RESTORE PSI AND W HERE
C
      DO 264 J=1,NF
      DO 264 I=1,NP
      XDATA(I,J)=XSAVE(I,J)
  264 CONTINUE
      DO 263 J=1,NF+1
      DO 263 I=1,NY
      W(I,J)=WSAVE(I,J)
  263 CONTINUE        
C
      RETURN
      END
C
C  **********************************************************************
C    SUBROUTINE CORR2---CALLED BY BLACKB.  COMPUTES CORRELATION MATRIX
C     FOR INPUT MATRIX X AND COMPUTES THE VECTOR OF COLUMN SIGN CHANGES
C     WHICH IS STORED IN VECTOR LL.
C  **********************************************************************
C
      SUBROUTINE CORR2(NP,NY,X,R,LL,MPOS,KS,KPOS,IPRNT)
      DIMENSION X(3539,152),R(152,152),SA(152,152),SB(152,152),
     CSD(152,152),LL(152),MPOS(152),SC(152,152)
      COMMON /AREA1/ JR,LR
  200 FORMAT(1X,50F7.3)
      DO 1 J=1,NY
      DO 1 JJ=1,NY
      SA(J,JJ)=0.0
      SB(J,JJ)=0.0
      SC(J,JJ)=0.0
  1   SD(J,JJ)=0.0
      DO 40 I=1,NP
      DO 31 J=1,NY
      DO 31 JJ=1,J
      IF(X(I,J).EQ.-999.0)GO TO 31
      IF(X(I,JJ).EQ.-999.0)GO TO 31
      SA(J,JJ)=SA(J,JJ)+X(I,J)
      IF(J.NE.JJ)SA(JJ,J)=SA(JJ,J)+X(I,JJ)
      SB(J,JJ)=SB(J,JJ)+X(I,J)*X(I,J)
      IF(J.NE.JJ)SB(JJ,J)=SB(JJ,J)+X(I,JJ)*X(I,JJ)
      SC(J,JJ)=SC(J,JJ)+X(I,J)*X(I,JJ)
      SC(JJ,J)=SC(J,JJ)
      SD(J,JJ)=SD(J,JJ)+1.0
  31  CONTINUE
  40  CONTINUE
      DO 32 J=1,NY
      DO 32 JJ=1,J
      AA=SD(J,JJ)*SC(J,JJ)-SA(J,JJ)*SA(JJ,J)
      BB=SD(J,JJ)*SB(J,JJ)-SA(J,JJ)*SA(J,JJ)
      CC=SD(J,JJ)*SB(JJ,J)-SA(JJ,J)*SA(JJ,J)
      BBCC=BB*CC
      IF(BBCC.LE..0)R(JJ,J)=0.0
      IF(BBCC.LE..0)GO TO 343
      R(JJ,J)=AA/SQRT(BB*CC)
  343 CONTINUE
  32  R(J,JJ)=R(JJ,J)
      IF(IPRNT.EQ.1)GO TO 62
      DO 34 J=1,NY
  34  WRITE(JR,200)(R(J,JJ),JJ=1,NY)
  62  BB=-99.0
C
C  FIND ROW WITH LARGEST TOTAL SUM OF ABSOLUTE VALUED CORRELATIONS
C
      KS=0
      DO 50 J=1,NY
      SUM=0.0
      DO 51 JJ=1,NY
  51  SUM=SUM+ABS(R(J,JJ))
      BB=AMAX1(SUM,BB)
      IF(BB.EQ.SUM)KS=J
  50  CONTINUE
      DO 52 J=1,NY
      IF(R(KS,J).LE.0.0)LL(J)=-1
  52  IF(R(KS,J).GT.0.0)LL(J)=1
C
C  ITERATIVELY CHANGE SIGNS OF COLUMNS TO MAXIMIZE NUMBER OF ENTRIES
C   IN THE CORRELATION MATRIX WHICH ARE POSITIVE.  THIS VECTOR IS THEN
C   RETURNED AS THE SIGN CHANGES FOR THE DATA MATRIX X.
C
      NYD2=(NY-1)/2
      KPOS=0
      DO 60 JK=1,NY
      DO 60 J=1,NY
      KK=0
      KSUM=0
      DO 61 JJ=1,NY
      AA=R(J,JJ)*FLOAT(LL(JJ))*FLOAT(LL(J))
      IF(JK.EQ.NY.AND.AA.GE.0.0)KPOS=KPOS+1
      IF(JK.EQ.NY.AND.AA.GE.0.0)KSUM=KSUM+1
  61  IF(AA.LT.0.0)KK=KK+1
      IF(KK.GT.NYD2)LL(J)=LL(J)*(-1)
      IF(JK.EQ.NY)MPOS(J)=KSUM
  60  IF(KK.GT.NYD2)KS=999
      RETURN
      END
C
C  ************************************************************************
C    SUBROUTINE REG---CALLED BY BLACKB.  PERFORMS REGRESSION TO ESTIMATE
C      W AND c.
C  ************************************************************************
C
      SUBROUTINE REG(NP,NF,NY,TSUM,W,XS,X,PSI,IPRNT,ILAST,KKK)
      DIMENSION XS(3539,152),PSI(3539,152),A(127,127),B(127,127),
     CW(152,127),C(152),TSUM(408),X(3539,152),LLL(152),FV1(127),
     CXT(3539,152),R(152,152),LL(152),RSUM(152),MPOS(152),WVEC(127),
     CZMAT(127,127),FV2(127)
      COMMON /AREA1/ JR,LR
      COMMON /XSREG/ AREG,BREG
  100 FORMAT(' PERFORMANCE INDEX MATRIX INVERSE=',2I5)
  101 FORMAT(' PERFORMANCE INDEX EIGENVALUE/VECTOR ROUTINE=',3I5)
  102 FORMAT(2I5,50F13.5)
  111 FORMAT(1X,8A1,13F10.4)
  200 FORMAT(3I5,15F10.4/15x,15f10.4/15x,15f10.4)
  250 FORMAT(' DIMENSION=',I3,1X,'TOTAL SSE REG1=',F15.4)
  300 FORMAT(' SSE AND FINAL WEIGHT MATRIX')
      NF1=NF+1
      DO 15 K=1,NY
      LLL(K)=0
      TSUM(K)=0.0
      C(K)=0.0
      DO 15 J=1,NF1
  15  W(K,J)=0.0
C
C  IF ILAST = 1 THEN ONLY PERFORM THE ESTIMATE OF W AND c FOR THE 
C   CURRENT COLUMN OF P.
C  IF ILAST = 0 THEN ESTIMATE W AND c ASSUMING NF=1, THEN ASSUMING
C   NF=2, UP TO NF=NF.  THIS ALLOWS THE COMPUTATION OF THE SS ACCOUNTED
C   FOR BY A 1 DIMENSION PW' + Jc' MODEL, A 2 DIMENSION PW' + Jc' MODEL,
C   AND SO ON.
C
      IF(ILAST.EQ.1)KKA=NF
      IF(ILAST.EQ.0)KKA=1
      DO 11 KK=KKA,NF
      DO 16 K=1,NY
      DO 16 J=1,NF+1
  16  W(K,J)=0.0
C
C  RUN REGRESSION TO ESTIMATE W AND c ONE COLUMN AT A TIME
C   BECAUSE OF MISSING DATA
C
      NF1=KK+1
      NF11=KK+2
      DO 7 K=1,NY
      LLL(K)=0
C
C  COMPUTE [P'P]-1
C
      DO 2 J=1,NF1
      DO 2 JJ=1,NF1
      SUM=0.0
      DO 1 I=1,NP
      IF(XS(I,K).EQ.-999.0)GO TO 1
      SUM=SUM+PSI(I,J)*PSI(I,JJ)
  1   CONTINUE
  2   A(J,JJ)=SUM
      call rs(127,nf1,a,wvec,1,ZMAT,fv1,fv2,ier)
C      IF(ILAST.EQ.0)THEN
C         WRITE(23,101)NP,NF1,IER
C         WRITE(23,102)NP,NF1,(WVEC(J),J=1,NF1)
C         WRITE(*,101)NP,NF1,IER
C         WRITE(*,102)NP,NF1,(WVEC(J),J=1,NF1)
C      ENDIF
      DO 60 I=1,NF1
      DO 60 KX=1,NF1
      SUM=0.0
      DO 61 J=1,NF1
      IF(ABS(WVEC(J)).GT..0001)THEN
          SUM=SUM+ZMAT(KX,J)*(1.0/WVEC(J))*ZMAT(I,J)
      ENDIF
  61  CONTINUE
  60  B(I,KX)=SUM
C
C  COMPUTE [P'P]-1*P'X = W'/c'
C
      DO 3 I=1,NP
      IF(XS(I,K).EQ.-999.0)GO TO 3
      DO 5 J=1,NF1
      SUM=0.0
      DO 4 JJ=1,NF1
  4   SUM=SUM+B(J,JJ)*PSI(I,JJ)
  5   C(J)=SUM
      DO 6 J=1,NF1
  6   W(K,J)=W(K,J)+C(J)*XS(I,K)
  3   CONTINUE
C
C  CALCULATE R-SQUARE AND SSE FOR REGRESSION
C
      ESUM=0.0
      DO 8 I=1,NP
      IF(XS(I,K).EQ.-999.0)GO TO 8
      LLL(K)=LLL(K)+1
      SUM=0.0
      DO 9 J=1,NF1
  9   SUM=SUM+PSI(I,J)*W(K,J)
      ESUM=ESUM+(SUM-XS(I,K))**2
      X(I,K)=SUM-XS(I,K)
      XT(I,1)=SUM
      XT(I,2)=XS(I,K)
  8   CONTINUE
      W(K,NF11)=ESUM
      TSUM(KK)=TSUM(KK)+ESUM
      call CORR2(NP,2,XT,R,LL,MPOS,KS,KPOS,1)
      RSUM(K)=R(1,2)*R(1,2)
  7   CONTINUE
C
C  END OF REGRESSION LOOP FOR CURRENT DIMENSION
C
      IF(ILAST.EQ.1)GO TO 90
C
C  IF ILAST = 0 THEN CALCULATE THE R-SQUARE FOR THE CURRENT
C   NUMBER OF DIMENSIONS
C
      DO 888 I=1,NP
      DO 88 K=1,NY
      SUM=0.0
      DO 89 J=1,NF1
  89  SUM=SUM+PSI(I,J)*W(K,J)
  88  XT(I,K)=SUM
  888 CONTINUE
      call RSQUR(NP,NY,RR,XT,XS)
      TSUM(KK+NY)=RR
  90  CONTINUE
      IF(IPRNT.EQ.1)GO TO 333
      WRITE(JR,300)
      DO 10 J=1,NY
  10  WRITE(LR,200)KK,J,LLL(J),W(J,NF11),RSUM(J),(W(J,JJ),JJ=1
     C,NF1)
  333 CONTINUE
      IF(ILAST.EQ.1)WRITE(JR,250)KKK,TSUM(KK)
      IF(ILAST.EQ.0)WRITE(JR,250)KK,TSUM(KK)
      AREG=TSUM(KK)
  11  CONTINUE
C
C  END OF DIMENSION ITERATION LOOP--ONLY IF ILAST = 0
C
      RETURN
      END
C
C  **************************************************************************
C    SUBROUTINE REG2---CALLED BY BLACKB.  PERFORMS REGRESSION TO ESTIMATE P.
C  **************************************************************************
C
      SUBROUTINE REG2(NP,NF,NY,W,XS,X,PSI,SQU,PXB,PXS,KKK)
      DIMENSION W(152,127),X(3539,152),XS(3539,152),PSI(3539,152),
     CA(152,127),V(152),SQU(152),Y(152)
      COMMON /AREA1/ JR,LR
      COMMON /XSREG/ AREG,BREG
      NF1=NF+1
      ESUM=0.0
      PXB=0.0
      PXS=0.0
      XNS=0.0
C
C  REGRESS ONE ROW AT A TIME BECAUSE OF MISSING DATA
C
      DO 1 I=1,NP
      KK=0
C
C  SET UP DEPENDENT VARIABLE-- Y(NY) = X[I,NY] - NY COL. MEANS
C    AND PUT W(NY,NF) INTO MATRIX A(NY,NF)
C
      DO 2 J=1,NY
      V(J)=0.0
      IF(XS(I,J).EQ.-999.0)GO TO 2
      KK=KK+1
      Y(KK)=XS(I,J)-W(J,NF1)
      DO 3 JJ=1,NF
  3   A(KK,JJ)=W(J,JJ)
  2   CONTINUE
C
C  CALL SUBROUTINE REGA TO PERFORM LEAST SQUARES
C
      NS=KK
      call REGA(NS,NF,A,Y,V)
C
C  STORE ESTIMATED ROW ENTRIES OF P AND COMPUTE SSE
C
      DO 5 K=1,NY
      SUM=0.0
      IF(XS(I,K).EQ.-999.0)GO TO 5
      DO 4 J=1,NF
      PSI(I,J)=V(J)
      SUM=SUM+PSI(I,J)*W(K,J)
  4   CONTINUE
      SUM=SUM+W(K,NF1)
      X(I,K)=SUM-XS(I,K)
      ESUM=ESUM+(SUM-XS(I,K))**2
  5   CONTINUE
      PXB=PXB+PSI(I,1)
      PXS=PXS+PSI(I,1)**2
      XNS=XNS+1.0
  1   CONTINUE
C
C  END OF REGRESSION LOOP
C
C  PXB IS THE SUM OF THE ESTIMATED COLUMN OF P AND
C  PXS IS THE VARIANCE OF THE ESTIMATED COLUMN OF P.
C  THESE ARE RETURNED TO BLACKB FOR ADJUSTMENT PURPOSES
C
      PXB=PXB/XNS
      PXS=PXS-XNS*PXB*PXB
      SQU(KKK)=ESUM
      WRITE(JR,350)KKK,ESUM
  350 FORMAT(' DIMENSION=',I3,1X,'TOTAL SSE REG2=',F15.4)
      BREG=ESUM
      RETURN
      END
C
C  **************************************************************************
C    SUBROUTINE REGA---CALLED BY REG2.  PERFORMS THE REGRESSION:
C
C         [W'W]-1*W'[X(I,NY) - c']
C
C      TO GET THE ROW ENTRIES OF P.
C  **************************************************************************
C
      SUBROUTINE REGA(NS,NF,A,Y,V)
      DIMENSION A(152,127),Y(152),B(127,127),C(127,127),V(152),
     CBB(127,152),ZMAT(127,127),FV1(127),FV2(127),WVEC(127)
      COMMON /AREA1/ JR,LR
  101 FORMAT(' PERFORMANCE INDEX EIGENVALUE/VECTOR ROUTINE=',3I5)
  102 FORMAT(2I5,30F10.4)
      DO 1 J=1,NF
      DO 1 JJ=1,NF
      SUM=0.0
      DO 2 I=1,NS
  2   SUM=SUM+A(I,J)*A(I,JJ)
  1   B(J,JJ)=SUM
      call rs(127,nf,B,wvec,1,ZMAT,fv1,fv2,ier)
C      WRITE(*,101)NS,NF,IER
C      WRITE(*,102)NS,NF,(WVEC(J),J=1,NF)
      DO 60 I=1,NF
      DO 60 K=1,NF
      SUM=0.0
      DO 61 J=1,NF
      IF(ABS(WVEC(J)).GT..0001)THEN
          SUM=SUM+ZMAT(K,J)*(1.0/WVEC(J))*ZMAT(I,J)
      ENDIF
  61  CONTINUE
  60  C(I,K)=SUM
      DO 3 I=1,NS
      DO 3 J=1,NF
      SUM=0.0
      DO 4 JJ=1,NF
  4   SUM=SUM+C(J,JJ)*A(I,JJ)
  3   BB(J,I)=SUM
      DO 5 JJ=1,NF
      SUM=0.0
      DO 6 J=1,NS
  6   SUM=SUM+BB(JJ,J)*Y(J)
  5   V(JJ)=SUM
      RETURN
      END
C
C  ***************************************************************************
C    SUBROUTINE RSQUR---CALLED BY REG.  COMPUTES THE SIMPLE PEARSON R-SQUARE
C     BETWEEN TWO INPUT MATRICES---A(NOBS,NY) AND B(NOBS,NY)
C  ***************************************************************************
C
      SUBROUTINE RSQUR(NP,NY,R,A,B)
      DIMENSION A(3539,152),B(3539,152)
      COMMON /AREA1/ JR,LR
      ASUM=0.0
      BSUM=0.0
      CSUM=0.0
      DSUM=0.0
      ESUM=0.0
      XNT=0.0
      DO 1 I=1,NP
      DO 1 J=1,NY
      IF(A(I,J).EQ.-999.0)GO TO 1
      IF(B(I,J).EQ.-999.0)GO TO 1
      ASUM=ASUM+A(I,J)
      BSUM=BSUM+B(I,J)
      CSUM=CSUM+A(I,J)*A(I,J)
      DSUM=DSUM+B(I,J)*B(I,J)
      ESUM=ESUM+A(I,J)*B(I,J)
      XNT=XNT+1.0
  1   CONTINUE
      AA=XNT*ESUM-ASUM*BSUM
      BB=XNT*CSUM-ASUM*ASUM
      CC=XNT*DSUM-BSUM*BSUM
      R=(AA*AA)/(BB*CC)
      RETURN
      END
C
C  ***************************************************************************
C    SUBROUTINE PSIPRM---CALLED BY BLACKB.  CALCULATES P'P AND WRITES IT OUT.
C  ***************************************************************************
C
      SUBROUTINE PSIPRM(NP,NF,PSI)
      DIMENSION PSI(3539,152),R(127,127)
      COMMON /AREA1/ JR,LR
  200 FORMAT(1X,50F10.4)
      DO 1 J=1,NF
      DO 1 K=1,NF
      SUM=0.0
      DO 2 I=1,NP
      SUM=SUM+PSI(I,J)*PSI(I,K)
  2   CONTINUE
  1   R(J,K)=SUM
      DO 3 I=1,NF
  3   WRITE(LR,200)(R(I,J),J=1,NF)
      RETURN
      END

C
C
C  ************************************************************************
C    SORT SUBROUTINE--SORTS A VECTOR 'A' OF REAL ELEMENTS INTO ASCENDING
C    ORDER.  'LA' IS THE NUMBER OF ELEMENTS TO BE SORTED AND 'IR' IS A
C    VECTOR OF INTEGERS THAT RECORDS THE PERMUTATIONS--USUALLY SET TO
C    1,2,3,4,...
C  ************************************************************************
C
C
      SUBROUTINE RSORT(A,LA,IR)
      DIMENSION A(LA),IU(21),IL(21),IR(LA)
      IF (LA.LE.0) RETURN
      M = 1
      I = 1
      J = LA
      R = .375
    5 IF (I.EQ.J) GO TO 45
      IF (R.GT..5898437) GO TO 10
      R = R+3.90625E-2
      GO TO 15 
   10 R = R-.21875 
   15 K = I 
C
C SELECT A CENTRAL ELEMENT OF THE  
C ARRAY AND SAVE IT IN LOCATION T  
C
      IJ = I+(J-I)*R 
      T = A(IJ)   
      IT = IR(IJ) 
C
C FIRST ELEMENT OF ARRAY IS GREATER
C THAN T, INTERCHANGE WITH T       
C
      IF (A(I).LE.T) GO TO 20  
      A(IJ) = A(I) 
      A(I) = T     
      T = A(IJ) 
      IR(IJ) = IR(I)  
      IR(I) = IT
      IT = IR(IJ) 
   20 L = J
C
C IF LAST ELEMENT OF ARRAY IS LESS THAN
C T, INTERCHANGE WITH T
C
      IF (A(J).GE.T) GO TO 30
      A(IJ) = A(J)
      A(J) = T
      T = A(IJ)
      IR(IJ) = IR(J)
      IR(J) = IT
      IT = IR(IJ)
C
C IF FIRST ELEMENT OF ARRAY IS GREATER
C THAN T, INTERCHANGE WITH T
C
      IF (A(I).LE.T) GO TO 30
      A(IJ) = A(I)
      A(I) = T
      T = A(IJ)
      IR(IJ) = IR(I)
      IR(I) = IT
      IT = IR(IJ)
      GO TO 30
   25 IF (A(L).EQ.A(K)) GO TO 30
      TT = A(L)
      A(L) = A(K)
      A(K) = TT
      ITT = IR(L)
      IR(L) = IR(K)
      IR(K) = ITT
C
C FIND AN ELEMENT IN THE SECOND HALF OF
C THE ARRAY WHICH IS SMALLER THAN T
C
   30 L = L-1
      IF (A(L).GT.T) GO TO 30
C
C FIND AN ELEMENT IN THE FIRST HALF OF
C THE ARRAY WHICH IS GREATER THAN T
C
   35 K = K+1
      IF (A(K).LT.T) GO TO 35
C
C INTERCHANGE THESE ELEMENTS
C
      IF (K.LE.L) GO TO 25
C
C SAVE UPPER AND LOWER SUBSCRIPTS OF
C THE ARRAY YET TO BE SORTED
C
      IF (L-I.LE.J-K) GO TO 40
      IL(M) = I
      IU(M) = L
      I = K
      M = M+1
      GO TO 50
   40 IL(M) = K
      IU(M) = J
      J = L
      M = M+1
      GO TO 50
C
C BEGIN AGAIN ON ANOTHER PORTION OF
C THE UNSORTED ARRAY
C
   45 M = M-1
      IF (M.EQ.0) RETURN
      I = IL(M)
      J = IU(M)
   50 IF (J-I.GE.11) GO TO 15
      IF (I.EQ.1) GO TO 5
      I = I-1
   55 I = I+1
      IF (I.EQ.J) GO TO 45
      T = A(I+1)
      IT = IR(I+1)
      IF (A(I).LE.T) GO TO 55
      K = I
   60 A(K+1) = A(K)
      IR(K+1) = IR(K)
      K = K-1
      IF (T.LT.A(K)) GO TO 60
      A(K+1) = T
      IR(K+1) = IT
      GO TO 55
      END
